/*
PolyGun

Copyright (c) 2023 kacperks https://kacperks.cubesoftware.xyz

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#include "chunk.hpp"

#include "../engine/greedy_meshing.hpp"

namespace polygun::world { 
	Chunk::Chunk() {
		for (int z = 0; z < CHUNK_SIZE; z++) {
			for (int y = 0; y < CHUNK_SIZE; y++) {
				for (int x = 0; x < CHUNK_SIZE; x++) {
					chunk_data[z][y][x] = 0;
					
				}
			}
		}
	}

	void Chunk::add_node(int node_to_add, glm::vec3 pos) {
		chunk_data[(int)pos.z][(int)pos.y][(int)pos.x] = node_to_add;
	}

	bool Chunk::is_air(glm::vec3 pos) {
		return chunk_data[(int)pos.z][(int)pos.y][(int)pos.x] == 0;
	}

	int Chunk::get_node(glm::vec3 pos) {
		return chunk_data[(int)pos.z][(int)pos.y][(int)pos.x];
	}

	bool Chunk::is_neighbour_air(glm::vec3 pos) {
		if (pos.x+1 == CHUNK_SIZE) {
			return true;
		}
		if (pos.x-1 == CHUNK_SIZE) {
			return true;
		}
		if (pos.y+1 == CHUNK_SIZE) {
			return true;
		}
		if (pos.y-1 == CHUNK_SIZE) {
			return true;
		}
		if (pos.z+1 == CHUNK_SIZE) {
			return true;
		}
		if (pos.z-1 == CHUNK_SIZE) {
			return true;
		}

		if (pos.x+1 == 0) {
			return true;
		}
		if (pos.x-1 == 0) {
			return true;
		}
		if (pos.y+1 == 0) {
			return true;
		}
		if (pos.y-1 == 0) {
			return true;
		}
		if (pos.z+1 == 0) {
			return true;
		}
		if (pos.z-1 == 0) {
			return true;
		}

		return false;
	}
}
